unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure nouveau_jeu ;
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure affiche_jeu ;
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const BON        = +1 ;
      MOYEN      =  0 ;
      MAUVAIs    = -1 ;
      ORDINATEUR = -1 ;
      JOUEUR     = +1 ;
      PERSONNE   =  0 ;

var t             : array[0..2,0..2] of integer ;
    meilleur_coup : integer ;
    le_niveau     : integer ;

function note1(j : integer) : integer ;
var f : array[0..7] of integer ;
    i : integer ;
begin
f[0]:=t[0,0]+t[0,1]+t[0,2] ;f[1]:=t[1,0]+t[1,1]+t[1,2] ;
f[2]:=t[2,0]+t[2,1]+t[2,2] ;f[3]:=t[0,0]+t[1,0]+t[2,0] ;
f[4]:=t[0,1]+t[1,1]+t[2,1] ;f[5]:=t[0,2]+t[1,2]+t[2,2] ;
f[6]:=t[0,0]+t[1,1]+t[2,2] ;f[7]:=t[0,2]+t[1,1]+t[2,0] ;
note1:=BON     ;j:=3*j ;
for i:=0 to 7 do
    if f[i]=j then exit ; //--- on quitte avec la valeur "bon"
note1:=MOYEN   ;
end ;

function note2(j,nb : integer) : integer ;
var x,y,note,nb_coups : integer ;
begin
note2:=BON ;
nb_coups:=0 ;
for x:=0 to 2 do
for y:=0 to 2 do
    if t[x,y]=PERSONNE then
       begin
       t[x,y]:=j ;
       note:=note1(j) ;
       if note=BON then inc(nb_coups) ;
       t[x,y]:=PERSONNE ;
       if nb_coups=nb then exit ; //--- on quitte avec la valeur "bon"
       end ;
note2:=MOYEN ;
end ;

function coup_obligatoire(j : integer) : integer ;
var x,y,note : integer ;
begin
coup_obligatoire:=-1 ;
for y:=0 to 2 do
for x:=0 to 2 do
    if t[x,y]=PERSONNE then
       begin
       t[x,y]:=j ;note:=note1(j) ;t[x,y]:=PERSONNE ;
       if note=BON then
          begin
          coup_obligatoire:=y*10+x ;
          exit ;
          end ;
       end ;
end ;

procedure jeu(coef,niveau : integer ;var note,remonte : integer) ;
var x,y,z,nb : integer ;
    la_note  : integer ;
    monte    : integer ;
    nb_poss,nb_notes : integer ;
begin
note:=MOYEN ;
remonte:=0 ;
if niveau=9 then
   note:=note1(JOUEUR*coef)
else
   begin
   z:=coup_obligatoire(JOUEUR*coef) ;nb:=1 ;
   if z=-1 then
      begin
      z:=coup_obligatoire(ORDINATEUR*coef) ;
      inc(nb) ;
      end ;
   if z>=0 then
      begin
      y:=z div 10 ;
      x:=z mod 10 ;
      t[x,y]:=JOUEUR*coef ;
      if note1(JOUEUR*coef)=BON then
         begin t[x,y]:=PERSONNE ;note:=MAUVAIS*coef ;exit ;end ;
      if note2(ORDINATEUR*coef,nb)=BON then
         begin t[x,y]:=PERSONNE ;note:=BON*coef ;exit ;end ;
      jeu(-coef,niveau+1,note,monte) ;
      t[x,y]:=PERSONNE ;remonte:=0 ;
      end
   else
      begin
      nb_poss:=0 ;nb_notes:=0 ;
      for y:=0 to 2 do
      for x:=0 to 2 do
          if t[x,y]=PERSONNE then
             begin
             t[x,y]:=JOUEUR*coef ;inc(nb_poss) ;
             case note1(JOUEUR*coef) of
               BON   : begin
                       t[x,y]:=PERSONNE ;note:=MAUVAIS*coef ;
                       exit
                       end ;
               MOYEN : begin
                       jeu(-coef,niveau+1,la_note,monte) ;
                       case coef of
                         +1 : begin
                              if la_note>MOYEN then inc(nb_notes) ;
                              if (la_note<MOYEN) and (monte<1) then
                                 begin
                                 t[x,y]:=PERSONNE ;note:=la_note ;
                                 inc(remonte) ;
                                 exit ;
                                 end ;
                              end ;
                         -1 : begin
                              if la_note<MOYEN then inc(nb_notes) ;
                              if (la_note>MOYEN) and (monte<1) then
                                 begin
                                 t[x,y]:=PERSONNE ;note:=-la_note ;
                                 inc(remonte) ;
                                 exit ;
                                 end ;
                             end ;
                         end ;
                       end ;
               end ;
             t[x,y]:=PERSONNE ;
             end ;
      if (nb_notes>0) and (nb_notes=nb_poss) then
         note:=coef*BON ;
      end ;
   end ;
end ;

procedure coup_ordinateur ;
var x,y,coup : integer ;
    la_note  : integer ;
    monte   : integer ;
begin
coup:=-1 ;inc(le_niveau) ;
meilleur_coup:=-1 ;
for y:=0 to 2 do
for x:=0 to 2 do
    if t[x,y]=PERSONNE then
       begin
       t[x,y]:=ORDINATEUR ;
       case note1(ORDINATEUR) of
         BON   : begin
                 t[x,y]:=PERSONNE ;
                 meilleur_coup:=y*10+x ;
                 exit ;
                 end ;
         MOYEN : begin
                 jeu(1,le_niveau,la_note,monte) ;
                 t[x,y]:=PERSONNE ;
                 case la_note of
                    MAUVAIS : if meilleur_coup=-1 then meilleur_coup:=y*10+x ;
                    MOYEN   : meilleur_coup:=y*10+x ;
                    BON     : begin
                              meilleur_coup:=y*10+x ;
                              exit ;
                              end ;
                    end ;
                 end ;
         end ;
       t[x,y]:=PERSONNE ;
       end ;
end ;


procedure tform1.nouveau_jeu ;
var x,y : integer ;
begin
le_niveau:=0 ;
with image1.picture.bitmap.canvas do
   begin
   brush.style:=bsSolid ;brush.color:=clWhite ;
   rectangle(0,0,90,90) ;
   rectangle(30,0,60,90) ;
   brush.style:=bsClear ;  //---- utilis pour l'criture des "x" et "o"
   rectangle(0,30,90,60) ;
   for x:=0 to 2 do
   for y:=0 to 2 do
       t[x,y]:=0 ;
   end ;
end ;

procedure tform1.affiche_jeu ;
var x,y : integer ;
begin
for x:=0 to 2 do
for y:=0 to 2 do
    if t[x,y]=JOUEUR then image1.picture.bitmap.canvas.textout(x*30+8,y*30+8,'X')
    else
    if t[x,y]=ORDINATEUR then image1.picture.bitmap.canvas.textout(x*30+8,y*30+8,'O') ;
end ;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
x:=x div 30 ;if x>2 then x:=2 ;
y:=y div 30 ;if y>2 then y:=2 ;
edit1.text:='X='+inttostr(1+x)+' ; Y='+inttostr(1+y) ;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if le_niveau>8 then
   exit ;
button3.hide ;
x:=x div 30 ;if x>2 then x:=2 ;
y:=y div 30 ;if y>2 then y:=2 ;
if t[x,y]<>0 then
   begin
   showMessage('Case dj occupe !') ;
   exit ;
   end ;
t[x,y]:=JOUEUR ;
affiche_jeu ;
inc(le_niveau) ;
if le_niveau<9 then coup_ordinateur ;
y:=meilleur_coup div 10 ;
x:=meilleur_coup mod 10 ;
t[x,y]:=ORDINATEUR ;
affiche_jeu ;
if note1(ORDINATEUR)=BON then
   begin
   showMessage('J''ai gagn !') ;
   le_niveau:=9 ;
   exit ;
   end ;
if note1(JOUEUR)=BON then
   begin
   showMessage('Vous avez gagn !') ;
   le_niveau:=9 ;
   exit ;
   end ;
if le_niveau=9 then showMessage('Match nul !') ;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
image1.picture.bitmap:=tbitmap.create ;
with image1.picture.bitmap do
   begin
   width:=90 ;
   height:=90 ;
   end ;
image1.autosize:=true ;
nouveau_jeu ;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
close ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
button3.show ;
nouveau_jeu ;
end;

procedure TForm1.Button3Click(Sender: TObject);
var x,y : integer ;
begin
randomize ;
x:=random(3) ;
y:=random(3) ;
t[x,y]:=ORDINATEUR ;
affiche_jeu ;
inc(le_niveau) ;
button3.hide ;
end;

end.
